<?php
 /* Mystique/digitalnature */
 get_header();
?>

  <!-- main content: primary + sidebar(s) -->
  <div id="main">
   <div id="main-inside" class="clearfix">

    <!-- primary content -->
    <div id="primary-content">

      <?php if (have_posts()) : ?>

       <?php $post = $posts[0]; // Hack. Set $post so that the_date() works. ?>
       <?php /* If this is a category archive */ if (is_category()) { ?>
       <h1 class="title archive-category"><?php echo single_cat_title(); ?></h1>
       <?php /* If this is a tag archive */ } elseif(is_tag()) { ?>
       <h1 class="title archive-tag"><?php printf( __('Posts tagged %s', 'mystique'), '<span class="altText">'.single_cat_title('', false).'</span>'); ?></h1>
       <?php /* If this is a daily archive */ } elseif (is_day()) { ?>
       <h1 class="title archive-day"><?php  printf(__('Archive for %s', 'mystique'), '<span class="altText">'.get_the_time(get_option('date_format')).'</span>');  ?></h1>
       <?php /* If this is a monthly archive */ } elseif (is_month()) { ?>
       <h1 class="title archive-month"><?php  printf(__('Archive for %s', 'mystique'), '<span class="altText">'.get_the_time(__('F, Y','mystique')).'</span>');  ?></h1>
       <?php /* If this is a yearly archive */ } elseif (is_year()) { ?>
       <h1 class="title archive-year"><?php  printf(__('Archive for year %s', 'mystique'), '<span class="altText">'.get_the_time(__('Y','mystique')).'</span>');  ?></h1>
       <?php /* If this is an author archive (should never show because the author template exists... */ } elseif (is_author()) { ?>
       <h1 class="title archive-author"><?php _e('Author archive','mystique'); ?></h1>
       <?php /* If this is a paged archive */ } elseif (isset($_GET['paged']) && !empty($_GET['paged'])) { ?>
       <h1 class="title"><?php _e('Blog Archives','mystique'); ?></h1>
       <?php } ?>
       <div class="divider"></div>

       <?php while (have_posts()): the_post();
        $post_preview = get_mystique_option('post_preview');
        $category = get_the_category();
        $category_name = $category[0]->cat_name;
        if(!empty($category_name)) $category_link = '<a href="'.get_category_link($category[0]->cat_ID).'">'.strip_string(34,$category_name).'</a>';
        else $category_link = "[...]";
        if(function_exists('the_post_thumbnail'))
         if (has_post_thumbnail()) $post_thumb = true; else $post_thumb = false;
       ?>
       <!-- post -->
       <div id="post-<?php the_ID(); ?>" <?php post_class('clearfix preview-'.$post_preview); ?>>

         <?php if($post_thumb): ?>
           <a class="post-thumb alignleft" href="<?php the_permalink(); ?>"><?php the_post_thumbnail('thumbnail'); ?></a>
         <?php endif; ?>

         <h2 class="title"><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php _e('Permanent Link:','mystique'); echo ' '; the_title_attribute(); ?>"><?php the_title(); ?></a></h2>

         <div class="post-date">
           <p class="day"><?php the_time(__('M jS','mystique')); ?></p>
         </div>

         <div class="post-info clearfix <?php if ($post_thumb) echo 'with-thumbs' ?>">
          <p class="author alignleft"><?php printf(__('Posted by %1$s in %2$s','mystique'),'<a href="'. get_author_posts_url(get_the_author_ID()) .'" title="'. sprintf(__("Posts by %s","mystique"), attribute_escape(get_the_author())).' ">'. get_the_author() .'</a>',$category_link);
            ?>
          <?php if(function_exists('the_views')): ?><span class="postviews">| <?php the_views(); ?></span><?php endif; ?>
          <?php edit_post_link(__('Edit','mystique'),' | '); ?>
          </p>

          <?php
          global $id, $comment;
          $number = get_comments_number($id);
          if (comments_open()): ?>
          <p class="comments alignright"><a href="<?php the_permalink() ?>#comments" class="<?php if ($number<1) echo "no"; ?> comments"><?php comments_number(__('No comments', 'mystique'), __('1 comment', 'mystique'), __('% comments', 'mystique')); ?></a></p>
          <?php endif; ?>
         </div>

         <?php if($post_preview<>'title'): ?>

           <div class="post-content clearfix">
            <?php if($post_preview=='excerpt') the_excerpt(); else the_content(__('Read the rest of this entry &raquo;', 'mystique')); ?>
           </div>

           <?php
            $post_tags = get_the_tags();
            if ($post_tags): ?>
            <div class="post-tags">
            <?php
              $tags = array();
              $i = 0;
              foreach($post_tags as $tag):
               $tags[$i] .=  '<a href="'.get_tag_link($tag->term_id).'" rel="tag" title="'.sprintf(__('%1$s (%2$s topics)'),$tag->name,$tag->count).'">'.$tag->name.'</a>';
               $i++;
              endforeach;
              echo implode(', ',$tags); ?>
            </div>
            <?php endif; ?>

         <?php endif; ?>
       </div>
       <!-- /post -->
       <?php endwhile; ?>

       <div class="page-navigation clearfix">
        <?php if(function_exists('wp_pagenavi')): wp_pagenavi(); else: ?>
        <div class="alignleft"><?php next_posts_link(__('&laquo; Older Entries','mystique')) ?></div>
        <div class="alignright"><?php previous_posts_link(__('Newer Entries &raquo;','mystique')) ?></div>
        <?php endif; ?>
       </div>

       <?php else:

       if ( is_category() ) { // If this is a category archive
       ?> <h2> <?php printf(__("Sorry, but there aren't any posts in the %s category yet.", "mystique"),single_cat_title('',false)); ?> </h2> <?php
       } else if ( is_date() ) { // If this is a date archive
       ?> <h2> <?php _e("Sorry, but there aren't any posts within this date."); ?> </h2> <?php
       } else if ( is_author() ) { // If this is a category archive
       $userdata = get_userdatabylogin(get_query_var('author_name'));
       ?> <h2> <?php printf(__("Sorry, but there aren't any posts by %s yet.", "mystique"),$userdata->display_name); ?> </h2> <?php
       } else {
       ?> <h2> <?php _e('No posts found.'); ?> </h2> <?php
       }
       get_search_form();
       endif;
       ?>

    </div>
    <!-- /primary content -->

    <?php get_sidebar(); ?>

   </div>
  </div>
  <!-- /main content -->

<?php get_footer(); ?>