<?php
/* Mystique/digitalnature */

// default theme settings
$default_settings =  array(
    'theme_version' => THEME_VERSION,
    'layout' => 'col-2-right',
    'main_width_2col' => '70',
    'sidebar1_width_3col' => '25',
    'sidebar2_width_3col' => '25',
    'color_scheme' => 'green',
    'font_style' => '0',
    'imageless' => '0',
    'footer_content' => '[credit] <br /> [rss] [xhtml] [top]',
    'navigation' => 'pages',
    'navigation_links' => 'Blogroll',
    'exclude_home' => '',
    'exclude_pages' => '',
    'exclude_categories' => '',
    'post_preview' => 'full',
    'sharethis' => '1',
    'featured_content' => 'All',
    'featured_home' => '0',
    'seo' => '1',
    'jquery' => '1',
    'lightbox' => '1',
    'user_css' => '',
    'logo' => '',
    'background' => '',
    'background_color' => '#000000',
    'ad_code_1' => '',
    'ad_code_2' => '',
    'ad_code_3' => '',
    'ad_code_4' => '',
    'ad_code_5' => '',
    'ad_code_6' => '',
    'head_code' => '',
    'remove_settings' => '0');

$themeurl = get_bloginfo('template_url');

function theme_install_notification(){ ?>
  <div class='updated fade'><p><?php printf(__('You can configure Mystique from the <a%s>theme settings</a> page.','mystique'),' href="themes.php?page=theme-settings"'); ?></p></div>
<?php
}

function verify_mystique_options(){
  global $default_settings;
  $current_settings = get_option('mystique');

  // if (version_compare(get_mystique_option('theme_version'), THEME_VERSION, '!=')) setup_mystique_options();
  if(!$current_settings):
    setup_mystique_options();
    add_action('admin_notices', 'theme_install_notification');
  else:

   // added in v1.18
   if(!$current_settings['main_width_2col']):
    $current_settings['main_width_2col'] = $default_settings['main_width_2col'];
    $current_settings['sidebar1_width_3col'] = $default_settings['sidebar1_width_3col'];
    $current_settings['sidebar2_width_3col'] = $default_settings['sidebar2_width_3col'];
    update_option('mystique' , $current_settings);
   endif;
 endif;
}

function setup_mystique_options() {
  global $default_settings;
  remove_mystique_options();
  update_option('mystique' , apply_filters('theme_default_settings', $default_settings)
  );
}

function remove_mystique_options() {
  delete_option('mystique');
  delete_option('mystique-twitter');
}

function get_mystique_option( $option ) {
  $get_mystique_options = get_option('mystique');
  return $get_mystique_options[$option];
}

function print_mystique_option( $option ) {
  $get_mystique_options = get_option('mystique');
  echo $get_mystique_options[$option];
}


function detectWPMU(){
  return function_exists('is_site_admin');
}

function detectWPMUadmin(){
  if(detectWPMU()) return is_site_admin();
}

function get_upload_dir($dir) {
  $uploadpath = wp_upload_dir();
  if ($uploadpath['baseurl']=='') $uploadpath['baseurl'] = get_bloginfo('siteurl').'/wp-content/uploads';
  return $uploadpath[$dir];
}

function mystique_setup_admin_js(){
  global $themeurl;
  wp_enqueue_script('jquery-ui-core', 'None', array('jquery'));
  wp_enqueue_script('mystique-settings', $themeurl.'/js/_admin/jquery.mystique-settings.min.js', array('jquery','jquery-ui-core'));
  wp_enqueue_script('codemirror', $themeurl.'/lib/codemirror/js/codemirror.js');
  ?>
 <?php
}

// load theme preview iframe with ajax (faster access to theme settings)
function getsitepreview() {
  check_ajax_referer("getsitepreview"); ?>
  <iframe id="themepreview" name="themepreview" src="<?php echo get_option('siteurl');  ?>?preview=true" style="width:96%;height:300px;border:8px solid #ddd"></iframe>
  <?php die();
}
add_action('wp_ajax_getsitepreview', 'getsitepreview');

function mystique_setup_admin_init_js(){
  global $themeurl;
  include('fontstyles.php');
  $nonce = wp_create_nonce('getsitepreview'); ?>
  <script type="text/javascript">
  /* <![CDATA[ */

  // init
  jQuery(document).ready(function () {

    // set up tabs
    jQuery("#theme-settings-tabs").minitabs({contentClass:'.sections',speed:333});

    // show link select box if navigation is set to show links
    jQuery('#opt_navigation').change(function() {
     jQuery('.opt_links, #page-list, #category-list').hide();
     if(jQuery(this).find('option:selected').attr('value')=='links') jQuery('.opt_links').show();
     if(jQuery(this).find('option:selected').attr('value')=='pages') jQuery('#page-list').show();
     if(jQuery(this).find('option:selected').attr('value')=='categories') jQuery('#category-list').show();
    });
    jQuery("#opt_navigation").change();

    jQuery('#opt_jquery').change(function() {
     jQuery('#opt_lightbox').attr("disabled", true);
     jQuery('#opt_sharethis').attr("disabled", true);
     if (jQuery(this).is(":checked")){
       jQuery('#opt_lightbox').attr("disabled", false);
       jQuery('#opt_sharethis').attr("disabled", false);
     }
    });
    jQuery("#opt_jquery").change();




    // not on IE
    if(jQuery.support.leadingWhitespace) jQuery('#layout-settings, #color-scheme').radio2select();


    jQuery.ajax({
		type: "post",url: "admin-ajax.php",data: { action: 'getsitepreview', _ajax_nonce: '<?php echo $nonce; ?>' },
		beforeSend: function() {jQuery("#themepreview-wrap .loading").show("slow");},
		complete: function() { jQuery("#themepreview-wrap .loading").hide("fast");},
		success: function(html){
			jQuery("#themepreview-wrap").html(html);
			jQuery("#themepreview-wrap").show("slow");


            // wait for load because of IE problems...
            jQuery('#themepreview').load(function(){

              // color scheme check
              jQuery('#color-scheme input[type=radio]').change(function() {
               $sel = jQuery(this).attr('value');
               jQuery('body',themepreview.document).append('<style type="text/css">@import "<?php echo $themeurl; ?>/color-'+$sel+'.css"; </style>');
              });
              jQuery("#color-scheme input[type=radio]").change();


              // font style check
              jQuery('#opt_font_style').change(function() {
               $sel = jQuery(this).find('option:selected').attr('value');
               switch($sel) {
                <?php foreach ($font_styles as $i => $value): ?>
                case '<?php echo $i; ?>':jQuery('body',themepreview.document).css('font-family','<?php echo $font_styles[$i]['code']; ?>');break;
                <?php endforeach; ?>
               }
              });
              jQuery("#opt_font_style").change();

              // bg color check
              jQuery('#colorpicker').farbtastic('#opt_background_color');
              jQuery('#colorpicker').hide();
              jQuery('#opt_background_color').focus(function() { jQuery('#colorpicker').show('fast'); });
              jQuery('#opt_background_color').blur(function() {
              jQuery('#colorpicker').hide('fast');
                bg = jQuery(this).attr('value');
                if(bg!='#000000') jQuery('body,#page',themepreview.document).css('background',bg); else jQuery('body,#page',themepreview.document).removeAttr('style');
              });

              jQuery('#colorpicker').mousemove(function() {
                bg = jQuery('#opt_background_color').attr('value');
                if(bg!='#000000') jQuery('body,#page',themepreview.document).css('background',bg); else jQuery('body,#page',themepreview.document).removeAttr('style');
              });

               // 2 col sidebar resize
              jQuery("#slider-range-2col").slider({
                range: 'min',
                animate: true,
                min: 0,
                max: 100,
                value: <?php esc_attr(print_mystique_option('main_width_2col')); ?>,
                slide: function(event, ui) {
                    s1 = 100 - ui.value;

                    jQuery("#opt_main_width_2col").val(ui.value);

                    jQuery('#sidebar',themepreview.document).css({'width': s1+'%'});
                    jQuery('#primary-content',themepreview.document).css({'width': ui.value+'%'});
                }
              });

              // 3 col sidebar resize
              jQuery("#slider-range-3col").slider({
                range: true,
                animate: true,
                min: 0,
                max: 100,
                values: [<?php esc_attr(print_mystique_option('sidebar1_width_3col')); ?>, <?php $s2 = esc_attr(get_mystique_option('sidebar2_width_3col')); print 100-$s2; ?>],
                slide: function(event, ui) {
                    s2 = jQuery('#slider-range-3col').slider('option', 'max') - jQuery("#slider-range-3col").slider("values", 1);
                    mc = 100 - ui.values[0] - s2;

                    jQuery("#opt_sidebar1_width_3col").val(ui.values[0]);
                    jQuery("#opt_sidebar2_width_3col").val(s2);

                    jQuery('#sidebar',themepreview.document).css({'width': ui.values[0]+'%' ,'left': - (mc + s2) +'%'});
                    jQuery('#sidebar2',themepreview.document).css({'width': s2+'%' ,'left': ui.values[0]+'%'});
                    jQuery('#primary-content',themepreview.document).css({'width': mc+'%' ,'left': ui.values[0]+'%'});
                }
              });

              // remove links to other pages from iframe doc.
              jQuery('#themepreview').contents().find("a").each(function() {
                 $href = jQuery(this).attr('href');
                 if ($href && $href.indexOf("#") != 0) {
                   jQuery(this).attr("href","#");
                 }
              });

            });

       	}
	});

  });


  // codemirror
  var editor_footer_content = CodeMirror.fromTextArea('opt_footer_content', {
   height: "200px",
//   lineNumbers: true,
   parserfile: ["parsexml.js", "parsecss.js", "tokenizejavascript.js", "parsejavascript.js", "parsehtmlmixed.js"],
   stylesheet: ["<?php echo $themeurl; ?>/lib/codemirror/css/xmlcolors.css", "<?php echo $themeurl; ?>/lib/codemirror/css/jscolors.css", "<?php echo $themeurl; ?>/lib/codemirror/css/csscolors.css"],
   path: "<?php echo $themeurl; ?>/lib/codemirror/js/",
   iframeClass: 'iframe_footer_content'
  });

  <?php if (!detectWPMU() || detectWPMUadmin()): ?>
  var editor_head_code = CodeMirror.fromTextArea('opt_head_code', {
   height: "300px",
//   lineNumbers: true,
   parserfile: ["parsexml.js", "parsecss.js", "tokenizejavascript.js", "parsejavascript.js", "parsehtmlmixed.js", "../contrib/php/js/tokenizephp.js", "../contrib/php/js/parsephp.js",
                   "../contrib/php/js/parsephphtmlmixed.js"],
   stylesheet: ["<?php echo $themeurl; ?>/lib/codemirror/css/xmlcolors.css", "<?php echo $themeurl; ?>/lib/codemirror/css/jscolors.css", "<?php echo $themeurl; ?>/lib/codemirror/css/csscolors.css", "<?php echo $themeurl; ?>/lib/codemirror/contrib/php/css/phpcolors.css"],
   path: "<?php echo $themeurl; ?>/lib/codemirror/js/",
   iframeClass: 'iframe_head_code'
  });
  <?php endif; ?>

  var editor_user_css = CodeMirror.fromTextArea('opt_user_css', {
   height: "540px",
//   lineNumbers: true,
   parserfile: "parsecss.js",
   stylesheet: "<?php echo $themeurl; ?>/lib/codemirror/css/csscolors.css",
   path: "<?php echo $themeurl; ?>/lib/codemirror/js/",
   iframeClass: 'iframe_user_css'
  });

  /* ]]> */
  </script>
 <?php
}

function mystique_setup_admin_css($dir) {
  global $themeurl;
  wp_register_style('MystiqueSettings', $themeurl. '/lib/settings.css');
  wp_enqueue_style('MystiqueSettings');
}

function mystique_update_options() {
  check_admin_referer('theme-settings');
  if (!current_user_can('edit_themes')) wp_die(__('You are not authorised to perform this operation.', 'mystique'));
  $options = get_option('mystique');
  if (isset($_POST['layout'])) $options['layout'] = $_POST['layout'];
  if (isset($_POST['sidebar1_width_3col'])) $options['sidebar1_width_3col'] = $_POST['sidebar1_width_3col'];
  if (isset($_POST['sidebar2_width_3col'])) $options['sidebar2_width_3col'] = $_POST['sidebar2_width_3col'];
  if (isset($_POST['main_width_2col'])) $options['main_width_2col'] = $_POST['main_width_2col'];
  if (isset($_POST['background_color'])) $options['background_color'] = $_POST['background_color'];
  if (isset($_POST['font_style'])) $options['font_style'] = $_POST['font_style'];
  if (isset($_POST['color_scheme'])) $options['color_scheme'] = $_POST['color_scheme'];
  if (isset($_POST['imageless'])) $options['imageless'] = 1; else $options['imageless'] = 0;
  if (isset($_POST['footer_content'])) $options['footer_content'] = stripslashes($_POST['footer_content']);
  if (isset($_POST['navigation'])) $options['navigation'] = $_POST['navigation'];
  if (isset($_POST['navigation_links'])) $options['navigation_links'] = $_POST['navigation_links'];
  if (isset($_POST['exclude_pages'])) $options['exclude_pages'] = implode(',', $_POST['exclude_pages']);
  if (isset($_POST['exclude_categories'])) $options['exclude_categories'] = implode(',', $_POST['exclude_categories']);
  if (isset($_POST['exclude_home'])) $options['exclude_home'] = 1; else $options['exclude_home'] = 0;
  if (isset($_POST['post_preview'])) $options['post_preview'] = $_POST['post_preview'];
  if (isset($_POST['sharethis'])) $options['sharethis'] = 1; else $options['sharethis'] = 0;
  if (isset($_POST['featured_content'])) $options['featured_content'] = $_POST['featured_content'];
  if (isset($_POST['featured_home'])) $options['featured_home'] = 1; else $options['featured_home'] = 0;
  if (isset($_POST['seo'])) $options['seo'] = 1; else $options['seo'] = 0;
  if (isset($_POST['jquery'])) $options['jquery'] = 1; else $options['jquery'] = 0;
  if (isset($_POST['lightbox'])) $options['lightbox'] = 1; else $options['lightbox'] = 0;
  if (isset($_POST['user_css'])) $options['user_css'] = stripslashes($_POST['user_css']);
  if (!detectWPMU() || detectWPMUadmin())
   if (isset($_POST['head_code'])) $options['head_code'] = stripslashes($_POST['head_code']);
  if (isset($_POST['remove_settings'])) $options['remove_settings'] = 1; else $options['remove_settings'] = 0;

  for ($i=1; $i<=6; $i++):
   if (isset($_POST['ad_code_'.$i])) $options['ad_code_'.$i] = stripslashes($_POST['ad_code_'.$i]);
  endfor;

  if (isset($_POST['remove-logo'])):
    $options['logo'] = '';
  else:
    if ($_FILES["file-logo"]["type"]):

      // check mime type
      if(!eregi('image/', $_FILES['file-logo']['type'])):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=1'));
       exit(0);
      endif;

      // check if valid image
      $imageinfo = getimagesize($_FILES['file-logo']['tmp_name']);
      if($imageinfo['mime'] != 'image/gif' && $imageinfo['mime'] != 'image/jpeg' && $imageinfo['mime'] != 'image/png' && isset($imageinfo)):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=2'));
       exit(0);
      endif;

      $directory = get_upload_dir('basedir').'/';
      if(!@move_uploaded_file($_FILES["file-logo"]["tmp_name"],$directory.$_FILES["file-logo"]["name"])):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=3'));
       exit(0);
      endif;
      $options['logo'] = get_upload_dir('baseurl'). "/". $_FILES["file-logo"]["name"];
    endif;
  endif;

  if (isset($_POST['remove-background'])):
    $options['background'] = '';
  else:
    if ($_FILES["file-background"]["type"]):

      // check image/* mime type
      if(!eregi('image/', $_FILES['file-background']['type'])):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=1'));
       exit(0);
      endif;

      // check if valid image
      $imageinfo = getimagesize($_FILES['file-background']['tmp_name']);
      if($imageinfo['mime'] != 'image/gif' && $imageinfo['mime'] != 'image/jpeg' && $imageinfo['mime'] != 'image/png' && isset($imageinfo)):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=2'));
       exit(0);
      endif;

      $directory = get_upload_dir('basedir').'/';
      if(!@move_uploaded_file($_FILES["file-background"]["tmp_name"],$directory . $_FILES["file-background"]["name"])):
       wp_redirect(admin_url('themes.php?page=theme-settings&error=3'));
       exit(0);
      endif;

      $options['background'] = get_upload_dir('baseurl')."/".$_FILES["file-background"]["name"];
    endif;
  endif;

  update_option('mystique', $options);

  // reset?
  if (isset($_POST['reset'])) setup_mystique_options();

  wp_redirect(admin_url('themes.php?page=theme-settings&updated=true'));
}



function mystique_theme_settings() {
  global $themeurl;
  include('codehelpers.php');
  include('fontstyles.php');
  if (current_user_can('edit_themes')): ?>

  <div id="theme-settings" class="wrap clearfix">
   <?php screen_icon(); ?>
   <h2><?php _e('Mystique settings','mystique'); ?></h2>

   <form action="<?php echo admin_url('admin-post.php?action=mystique_update'); ?>" method="post" enctype="multipart/form-data">
   <?php wp_nonce_field('theme-settings'); ?>
   <?php if (isset($_GET['updated'])): ?>
   <div class="updated fade below-h2">
    <p><?php printf(__('Settings saved. %s', 'mystique'),'<a href="' . user_trailingslashit(get_bloginfo('url')) . '">' . __('View site','mystique') . '</a>'); ?></p>
   </div>
   <?php elseif (isset($_GET['error'])):
     $errors  = array(
       1 => _("Please upload a valid image file!","mystique"),
       2 => _("The file you uploaded doesn't seem to be a valid JPEG, PNG or GIF image","mystique"),
       3 => _("The image could not be saved on your server","mystique")
     );


   ?>
   <div class="error fade below-h2">
    <p><?php printf(__('Error: %s', 'mystique'),$errors[$_GET['error']]); ?></p>
   </div>
   <?php endif; ?>

   <!-- tabbed content -->
   <div id="theme-settings-tabs">
    <ul class="tabs clearfix">
     <li class="general"><a href='#tab-1'><?php _e("General","mystique"); ?></a></li>
     <li class="navigation"><a href='#tab-2'><?php _e("Design/colors","mystique"); ?></a></li>
     <li class="bglogo"><a href='#tab-3'><?php _e("Navigation","mystique"); ?></a></li>
     <li class="posts"><a href='#tab-4'><?php _e("Posts","mystique"); ?></a></li>
     <li class="seo"><a href='#tab-5'><?php _e("SEO","mystique"); ?></a></li>
     <li class="ads"><a href='#tab-6'><?php _e("Ads","mystique"); ?></a></li>
     <li class="adv"><a href='#tab-7'><?php _e("Advanced","mystique"); ?></a></li>
     <li class="usercss"><a href='#tab-8'><?php _e("User CSS","mystique"); ?></a></li>
    </ul>

    <!-- sections -->
    <div class="sections">

     <div class="section" id="tab-1">
      <table class="form-table" style="width: auto">

       <tr>
        <th scope="row"><p><?php _e("Layout style","mystique") ?><span><?php _e("Use page templates to apply these only to specific pages","mystique"); ?></span></p></th>
        <td id="layout-settings" class="clearfix">
         <div class="layout-box">
          <label for="layout-settings-col-1" class="layout col-1"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-1" value="col-1" <?php if(get_mystique_option('layout')=='col-1') echo 'checked="checked" '; ?>/>
         </div>

         <div class="layout-box">
          <label for="layout-settings-col-2-left" class="layout col-2-left"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-2-left" value="col-2-left" <?php if(get_mystique_option('layout')=='col-2-left') echo 'checked="checked" '; ?>/>
         </div>

         <div class="layout-box">
          <label for="layout-settings-col-2-right" class="layout col-2-right"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-2-right" value="col-2-right" <?php if(get_mystique_option('layout')=='col-2-right') echo 'checked="checked" '; ?>/>
         </div>

         <div class="layout-box">
          <label for="layout-settings-col-3" class="layout col-3"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-3" value="col-3" <?php if(get_mystique_option('layout')=='col-3') echo 'checked="checked" '; ?>/>
         </div>

         <div class="layout-box">
          <label for="layout-settings-col-3-left" class="layout col-3-left"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-3-left" value="col-3-left" <?php if(get_mystique_option('layout')=='col-3-left') echo 'checked="checked" '; ?>/>
         </div>

         <div class="layout-box">
          <label for="layout-settings-col-3-right" class="layout col-3-right"></label>
          <input class="radio" type="radio" name="layout" id="layout-settings-col-3-right" value="col-3-right" <?php if(get_mystique_option('layout')=='col-3-right') echo 'checked="checked" '; ?>/>
         </div>

        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Imageless layout","mystique") ?><span><?php _e("No background images; reduces page load downto just a few KB, with the cost of less graphic details","mystique"); ?></span></p></th>
        <td><input name="imageless" id="opt_imageless" type="checkbox" value="1" <?php checked('1', get_mystique_option('imageless')) ?> /></td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Footer content","mystique"); ?><span><?php _e("You can post HTML code",'mystique') ?></span></p></th>
        <td>
         <textarea id="opt_footer_content" rows="4" cols="50" name="footer_content" class="code"><?php echo get_mystique_option('footer_content') ?></textarea><br />

         <?php printf(__("Use the following short codes for convenient adjustments: <br />%s",'mystique'),'<code>[rss]</code> <code>[copyright]</code> <code>[credit]</code> <code>[ad code=#]</code> <code>[wp-link]</code> <code>[theme-link]</code> <code>[login-link]</code> <code>[blog-title]</code> <code>[xhtml]</code> <code>[css]</code> <code>[top]</code>.'); ?>
        </td>
       </tr>

      </table>
     </div>

     <div class="section" id="tab-2">
      <div id="themepreview-wrap"><div class="clearfix"><div class="loading"><?php _e("Loading site preview...","mystique"); ?></div></div></div>
      <table class="form-table" style="width: auto">

       <?php
        $layout = get_mystique_option('layout');
        if ($layout=='col-3'):
       ?>
       <tr>
        <th><p><?php _e('Sidebar(s) vs Main Content ratio','mystique'); ?></p></th>
        <td style="min-width: 600px;">
         <input name="sidebar1_width_3col" id="opt_sidebar1_width_3col" type="hidden" value="<?php esc_attr(print_mystique_option('sidebar1_width_3col')); ?>" />
         <input name="sidebar2_width_3col" id="opt_sidebar2_width_3col" type="hidden" value="<?php esc_attr(print_mystique_option('sidebar2_width_3col')); ?>" />
         <div id="slider-range-3col"></div>

        </td>
       </tr>
       <?php
       elseif($layout=='col-2-right'):
       ?>
       <tr>
        <th><?php _e('Sidebar(s) vs Main Content ratio','mystique'); ?></th>
        <td style="min-width: 600px;">
         <input name="main_width_2col" id="opt_main_width_2col" type="hidden" value="<?php esc_attr(print_mystique_option('main_width_2col')); ?>" />
         <div id="slider-range-2col"></div>

        </td>
       </tr>
       <?php endif; ?>

       <tr>
        <th scope="row"><p><?php _e("Preferred font style","mystique"); ?><span><?php _e("Font priority and their availability","mystique"); ?></span></p></th>
        <td>
         <select name="font_style" id="opt_font_style">
          <?php foreach ($font_styles as $i => $value): ?>
          <option value="<?php echo $i; ?>" <?php if(get_mystique_option('font_style')==$i) echo 'selected="selected" '; ?>><?php echo $font_styles[$i]['desc']; ?></option>
          <?php endforeach; ?>
         </select>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Color scheme","mystique"); ?></p></th>
        <td id="color-scheme" class="clearfix">

         <?php if(get_mystique_option('imageless')): ?>
         <p class="error"><?php _e("Not available with <em>imageless</em> setting","mystique"); ?></p>
         <?php else: ?>
         <div class="color-box">
          <label for="color-box-green" class="color_scheme green"></label>
          <input class="radio" type="radio" name="color_scheme" id="color-box-green" value="green" <?php if(get_mystique_option('color_scheme')=='green') echo 'checked="checked" '; ?>/>
         </div>

         <div class="color-box">
          <label for="color-box-blue" class="color_scheme blue"></label>
          <input class="radio" type="radio" name="color_scheme" id="color-box-blue" value="blue" <?php if(get_mystique_option('color_scheme')=='blue') echo 'checked="checked" '; ?>/>
         </div>

         <div class="color-box">
          <label for="color-box-red" class="color_scheme red"></label>
          <input class="radio" type="radio" name="color_scheme" id="color-box-red" value="red" <?php if(get_mystique_option('color_scheme')=='red') echo 'checked="checked" '; ?>/>
         </div>

         <div class="color-box">
          <label for="color-box-grey" class="color_scheme grey"></label>
          <input class="radio" type="radio" name="color_scheme" id="color-box-grey" value="grey" <?php if(get_mystique_option('color_scheme')=='grey') echo 'checked="checked" '; ?>/>
         </div>


         <?php endif; ?>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Custom logo image","mystique"); ?><span><?php _e("Show a logo image instead of text; Upload the graphic file from your computer","mystique"); ?></span></p></th>
        <td>
         <?php if(is_writable(get_upload_dir('basedir'))): ?>
           <input type="file" name="file-logo" id="file-logo" />
           <?php if(get_mystique_option('logo')): ?>
           <div style="background: #000;margin-top:10px;overflow:hidden;"><img src="<?php echo get_mystique_option('logo'); ?>" style="padding:10px;" /></div>
           <button type="submit" class="button" name="remove-logo" value="0"><?php _e("Remove current image","mystique"); ?></button>
           <?php endif; ?>
         <?php else: ?>
         <p class="error" style="padding: 4px;"><?php printf(__("Directory %s doesn't have write permissions - can't upload!","mystique"),'<strong>'.get_upload_dir('basedir').'</strong>'); ?></p><p><?php _e("Check your upload path in Settings/Misc or CHMOD this directory to 755/777.<br />Contact your host if you don't know how","mystique"); ?></p>
         <?php endif; ?>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Custom background image","mystique"); ?><span><?php _e("Upload a new background/header image to replace the default one","mystique"); ?></span></p></th>
        <td>
         <?php if(is_writable(get_upload_dir('basedir'))): ?>
           <input type="file" name="file-background" id="file-background" />
           <?php if(get_mystique_option('background')): ?>
           <div style="background: #000;margin-top:10px;overflow:hidden;"><img src="<?php echo get_mystique_option('background'); ?>" style="padding:10px;" /></div>
           <button type="submit" class="button" name="remove-background" value="0"><?php _e("Remove current image","mystique"); ?></button>
           <?php endif; ?>
         <?php else: ?>
         <p class="error" style="padding: 4px;"><?php printf(__("Directory %s doesn't have write permissions - can't upload!","mystique"),'<strong>'.get_upload_dir('basedir').'</strong>'); ?></p><p><?php _e("Check your upload path in Settings/Misc or CHMOD this directory to 755/777.<br />Contact your host if you don't know how","mystique"); ?></p>
         <?php endif; ?>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Background color","mystique"); ?><span><?php _e("Leave Black (#000000) to keep the default background","mystique"); ?></span></p></th>
        <td>
         <input class="text" type="text" size="8" name="background_color" id="opt_background_color" value="<?php if(get_mystique_option('background_color')) esc_attr(print_mystique_option('background_color')); else echo '#000000'; ?>" />
         <div id="colorpicker"></div>
        </td>
       </tr>

      </table>
     </div>

     <div class="section" id="tab-3">
      <table class="form-table" style="width: auto;">
       <tr>
        <th scope="row"><p><?php _e("Top navigation shows","mystique"); ?></p></th>
        <td class="clearfix">
         <select name="navigation" id="opt_navigation" class="alignleft">
          <option value="pages" <?php if(get_mystique_option('navigation')=='pages') echo 'selected="selected" '; ?>><?php _e('Pages', 'mystique'); ?></option>
          <option value="categories" <?php if(get_mystique_option('navigation')=='categories') echo 'selected="selected" '; ?>><?php _e('Categories', 'mystique'); ?></option>
          <option value="links" <?php if(get_mystique_option('navigation')=='links') echo 'selected="selected" '; ?>><?php _e('Links', 'mystique'); ?></option>
         </select>
         <div class="hidden alignleft inline opt_links">
          <?php
           $taxonomy = 'link_category';
           $args ='';
           $terms = get_terms( $taxonomy, $args );
           if ($terms): ?>
             <?php _e("from category","mystique"); ?>
             <select name="navigation_links">
             <?php
             foreach($terms as $term) {
              if ($term->count > 0):
               if(get_mystique_option('navigation_links')==$term->name) $selected = 'selected="selected" '; else $selected='';
               echo '<option value="'.$term->name.'" '.$selected.'>'.$term->name.' ('.$term->count.' links)</option>';
              endif;
             }
             ?>
             </select>
             <?php
           else: ?>
             <p class="error"><?php _e("No links found","mystique"); ?></p>
           <?php
           endif;
          ?>
         </div>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Exclude from navigation","mystique"); ?><span><?php _e("Check the items you wish to hide from the main menu","mystique"); ?></span></p></th>
        <td>

          <?php if(get_option('show_on_front')<>'page'): ?>
          <ol class="nav-exclude">
            <li><input name="exclude_home" id="opt_exclude_home" type="checkbox" value="1" <?php checked( '1', get_mystique_option('exclude_home') ) ?> /><label> <a href="<?php echo get_settings('home'); ?>"><?php _e('Home','mystique'); ?></a> </label></li>
          </ol>
          <?php endif; ?>

          <ol class="nav-exclude hidden opt_links">
           <li><?php _e("(Use the private property to hide other links)","mystique"); ?></li>
          </ol>
          <?php

          class WalkerCategorySelect extends Walker {
           var $tree_type = 'category';
           var $db_fields = array ('parent' => 'parent', 'id' => 'term_id'); //TODO: decouple this
           var $selected = array();

           function WalkerCategorySelect($selected) { $this->selected = $selected; }

           function start_lvl(&$output, $depth) {
            $indent = str_repeat("\t", $depth);
            $output .= "\n$indent<ol>\n";
           }

           function end_lvl(&$output, $depth) {
            $indent = str_repeat("\t", $depth);
            $output .= "$indent</ol>\n";
           }

           function start_el(&$output, $category, $depth) {
            if ($depth) $indent = str_repeat("\t", $depth); else $indent = '';
            if (in_array($category->term_id, $this->selected)) $checked = ' checked="checked"'; else $checked = '';

            $output .= $indent. '<li>';
            $output .= '<input id="opt-category-'. $category->term_id. '" name="exclude_categories[]" type="checkbox" value="'. $category->term_id. '"'. $checked. ' />';
            $output .= '<label for="opt-category-'. $category->term_id. '"> <a href="' . get_category_link( $category->term_id ) . '">'.attribute_escape( $category->name).'</a> <span>('.intval($category->count).')</span> </label>';
           }

           function end_el(&$output, $page, $depth) { $output .= "</li>\n"; }
          }

          $categories = &get_categories();
          $nav_categories = explode(',', get_mystique_option('exclude_categories'));
          $walker = new WalkerCategorySelect($nav_categories);
          if (!empty($categories)): ?>
           <ol class="hidden nav-exclude" id="category-list">
           <?php echo $walker->walk($categories, 0, 0, array()); ?>
           </ol>
          <?php endif; ?>


          <?php
          class WalkerPageSelect extends Walker {
           var $tree_type = 'page';
           var $db_fields = array('parent' => 'post_parent', 'id' => 'ID');
           var $selected = array();

           function WalkerPageSelect($selected) { $this->selected = $selected; }

           function start_lvl(&$output, $depth) {
            $indent = str_repeat("\t", $depth);
            $output .= "\n$indent<ol>\n";
           }

           function end_lvl(&$output, $depth) {
            $indent = str_repeat("\t", $depth);
            $output .= "$indent</ol>\n";
           }

           function start_el(&$output, $page, $depth) {
            if ($depth) $indent = str_repeat("\t", $depth);	else $indent = '';
            if (in_array($page->ID, $this->selected)) $checked = ' checked="checked"'; else $checked = '';

            $output .= $indent. '<li>';
            $output .= '<input id="opt-page-'. $page->ID. '" name="exclude_pages[]" type="checkbox" value="'.$page->ID.'"'. $checked. ' /> <label for="opt-page-'.$page->ID.'"><a title="'. __('View page','mystique'). '" href="'.get_page_link($page->ID).'">'. apply_filters('the_title', $page->post_title). '</a></label>';
           }
           function end_el(&$output, $page, $depth) { $output .= "</li>\n"; }
          }

          $pages = &get_pages('sort_column=post_parent,menu_order');
          $nav_pages = explode(',', get_mystique_option('exclude_pages'));
          $walker = new WalkerPageSelect($nav_pages);
          if (!empty($pages)): ?>
           <ol class="hidden nav-exclude" id="page-list">
           <?php echo $walker->walk($pages, 0, 0, array()); ?>
           </ol>
          <?php endif; ?>

        </td>
       </tr>
      </table>
     </div>

     <div class="section" id="tab-4">
      <table class="form-table" style="width: auto">

       <tr>
        <th scope="row"><p><?php _e("Post previews","mystique"); ?><span><?php _e("The way posts are displayed on blog homepage and archive pages","mystique"); ?></span></p></th>
        <td>
         <select name="post_preview">
          <option value="full" <?php if(get_mystique_option('post_preview')=='full') echo 'selected="selected" '; ?>><?php _e('Full', 'mystique'); ?></option>
          <option value="excerpt" <?php if(get_mystique_option('post_preview')=='excerpt') echo 'selected="selected" '; ?>><?php _e('Excerpts', 'mystique'); ?></option>
          <option value="title" <?php if(get_mystique_option('post_preview')=='title') echo 'selected="selected" '; ?>><?php _e('Titles only', 'mystique'); ?></option>
         </select>
        </td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e('Enable "Share This Post" feature','mystique'); ?><span><?php _e("Uncheck this if you're using a social bookmaring plugin","mystique"); ?></span></p></th>
        <td><input id="opt_sharethis" name="sharethis" type="checkbox" value="1" <?php checked( '1', get_mystique_option('sharethis')) ?> /></td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Featured content source","mystique"); ?><span><?php _e("The last 5 posts from this category will be shown in the featured content area (in random order)","mystique"); ?></span></p></th>
        <td>
         <?php wp_dropdown_categories(array(
          'name' => 'featured_content',
          'selected' => get_mystique_option('featured_content'),
          'show_option_all' => __('- All categories', 'mystique'),
          'hide_empty' => 0,
          'orderby' => 'name',
          'show_count' => 1,
          'hierarchical' => 1)) ?>
        </td>
       </tr>


       <tr>
        <th scope="row"><p><?php _e("Display featured posts on blog/home page","mystique"); ?><span><?php _e('Use the "Page with Featured Content" template if you want it on specific pages','mystique'); ?></span></p></th>
        <td><input name="featured_home" type="checkbox" value="1" <?php checked( '1', get_mystique_option('featured_home') ) ?> /></td>
       </tr>

      </table>
     </div>

     <div class="section" id="tab-5">
      <table class="form-table" style="width: auto">
       <tr>
        <th scope="row"><p><?php _e("Additional site optimization for search engines","mystique"); ?><span><?php _e("Uncheck if you are using a SEO plugin!","mystique"); ?></span></p></th>
        <td><input name="seo" type="checkbox" id="opt_seo" value="1" <?php checked( '1', get_mystique_option('seo') ) ?> /></td>
       </tr>

       <tr>
        <th scope="row"></th>
        <td>
         <h3><?php _e("What does this do?","mystique"); ?></h3>
         <ul style="list-style: disc">
          <li><em><?php printf(__('enables canonical URLs for comments (duplicate content fix)','mystique')); ?></em></li>
          <li><em><?php printf(__('generates unique titles for posts with multiple comment pages (prevents duplicate titles)','mystique')); ?></em></li>
          <li><em><?php printf(__('no keywords are generated because they are <a %s>useless</a>','mystique'),'href="http://googlewebmastercentral.blogspot.com/2009/09/google-does-not-use-keywords-meta-tag.html" target="_blank"'); ?> </em></li>
         </ul>
        </td>
       </tr>

      </table>
     </div>

     <div class="section" id="tab-6">
      <table class="form-table" style="width: auto">

       <tr>
        <th scope="row">
         <p><?php printf(__("Advertisment blocks","mystique"),$i); ?><span><?php printf(__('Use the %s short code to insert these ads into posts, text widgets or footer','mystique'),'<code>[ad]</code>'); ?></span></p><br />
         <p><span><?php _e("Example:","mystique"); ?></span></p>
         <p><code>[ad code=4 align=center]</code></p>
        </th>
        <td class="clearfix">
         <?php for ($i=1; $i<=6; $i++): ?>
         <div class="alignleft">
          <label for="opt_ad_code_<?php echo $i; ?>"><?php printf(__("Ad code #%s:","mystique"),$i); ?></label><br />
          <textarea rows="8" cols="40" name="ad_code_<?php echo $i; ?>" id="opt_ad_code_<?php echo $i; ?>" class="code"><?php echo get_mystique_option('ad_code_'.$i) ?></textarea>
          <br /><br />
         </div>
         <?php endfor; ?>
        </td>
       </tr>


      </table>
     </div>

     <div class="section" id="tab-7">
      <table class="form-table" style="width: auto">
       <tr>
        <th scope="row"><p><?php _e("Use jQuery","mystique"); ?><span><?php _e("For testing purposes only. Only uncheck if you know what you're doing!","mystique"); ?></span></p></th>
        <td><input id="opt_jquery" name="jquery" type="checkbox" value="1" <?php checked( '1', get_mystique_option('jquery') ) ?> /></td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Enable theme built-in lightbox on all image links","mystique"); ?><span><?php _e("Uncheck if you prefer a lightbox plugin","mystique"); ?></span></p></th>
        <td><input id="opt_lightbox" name="lightbox" type="checkbox" value="1" <?php checked( '1', get_mystique_option('lightbox') ) ?> /></td>
       </tr>

       <tr>
        <th scope="row"><p><?php _e("Remove Mystique settings from the database after theme switch","mystique"); ?><span><?php _e("Uncheck this if you plan to keep Mystique as your default theme!","mystique"); ?></span></p></th>      <td>
         <input name="remove_settings" id="opt_remove_settings" type="checkbox" value="1" <?php checked( '1', get_mystique_option('remove_settings') ) ?> />
        </td>
       </tr>
      </table>

      <?php if (!detectWPMU() || detectWPMUadmin()): // disable this option for wpmu users, other than site admin (they shouldn't be allowed to execute php code) ?>
      <hr />
      <table class="form-table" style="width: auto">

       <tr>
        <th scope="row">
         <p><?php _e("Document head code","mystique"); ?><span><?php printf(__("PHP code to insert in the %s section of the XHTML document. Useful if you have plugins that require you to add stuff here, adding Analytics code etc.","mystique"),'<code>&lt;head&gt;</code>'); ?></span></p>
         <p><span class="warning"><?php _e("To output HTML only, close the PHP tag first.","mystique"); ?></span></p>
         <br />
         <p><span><?php _e("Examples and helpers:","mystique") ?></span></p>
         <br />
          <?php foreach($predefined_head_scripts as $id=>$code): ?>
          <button class="button" onclick="jQuery('#opt_head_code').appendVal('<?php echo '\n\n'.'<?php \/\/ '.$id.'?>\n'.jsspecialchars($code); ?>'); $current = editor_head_code.getCode(); editor_head_code.setCode($current+'<?php echo '\n\n'.'\<\?php \/\/ '.$id.'\n'.jsspecialchars($code).'\n\?\>'; ?>');" type="button"><?php echo $id; ?></button><br />
          <?php  endforeach; ?>
       </th>
        <td>
         <textarea rows="16" cols="60" name="head_code" id="opt_head_code" class="code"><?php echo get_mystique_option('head_code') ?></textarea>
        </td>
       </tr>

      </table>
      <?php endif; ?>
     </div>

     <div class="section" id="tab-8">
      <table class="form-table" style="width: auto">

       <tr>
        <th scope="row"><p><?php _e("Modify anything related to design using CSS code","mystique"); ?><span><?php printf(__("Check %s to see existing theme classes and properties","mystique"),'<a href="'.get_bloginfo('stylesheet_url').'">style.css</a>'); ?></span><br /><span class="warning"><?php _e("Avoid modifying theme files directly; use this option instead to preserve your changes after update","mystique"); ?></span></p>
         <br />
         <p><span><?php _e("Examples and helpers:","mystique") ?></span></p>
         <br />
         <?php
          foreach($predefined_css as $id=>$code): ?>
          <button class="button" onclick="jQuery('#opt_user_css').appendVal('<?php echo '\n\n'.'/* '.$id.' */\n'.jsspecialchars($code); ?>'); $current = editor_user_css.getCode(); editor_user_css.setCode($current+'<?php echo '\n\n'.'/* '.$id.' */\n'.jsspecialchars($code); ?>');" type="button"><?php echo $id; ?></button><br />
          <?php endforeach; ?>
        </th>
        <td valign="top">
         <textarea rows="30" cols="80" name="user_css" id="opt_user_css" class="code"><?php echo get_mystique_option('user_css') ?></textarea>
        </td>
       </tr>

      </table>
     </div>


    </div>
    <!-- /sections -->

   </div>
   <!-- /tabbed content -->
   <p><input type="submit" class="button-primary" name="submit" value="<?php _e("Save Changes","mystique"); ?>" /><input type="submit" class="button-primary" name="reset" value="<?php _e("Reset to Defaults","mystique"); ?>" /></p>
   </form>
   <hr />
   <div class="support">
    <form class="alignleft" action="https://www.paypal.com/cgi-bin/webscr" method="post"> <input name="cmd" type="hidden" value="_s-xclick" /> <input name="hosted_button_id" type="hidden" value="4605915" /> <input alt="Donate" name="submit" src="https://www.paypal.com/en_US/i/btn/btn_donate_SM.gif" type="image" /> <img src="https://www.paypal.com/en_US/i/scr/pixel.gif" border="0" alt="" width="1" height="1" /></form>
     <a href="http://digitalnature.ro/projects/mystique">Mystique</a> is a free theme developed by <a href="http://digitalnature.ro">digitalnature</a>.<br />You can support this project by donating.
   </div>


  </div>
  <?php endif;
}

function mystique_addmenu() {
  $page = add_theme_page(
    __('Mystique settings','mystique'),
    __('Mystique settings','mystique'),
       'edit_themes',
       'theme-settings',
       'mystique_theme_settings'
  );
  add_action("admin_print_scripts-$page", 'mystique_setup_admin_js');
  add_action("admin_footer-$page", 'mystique_setup_admin_init_js');
  add_action("admin_print_styles-$page", 'mystique_setup_admin_css');
}


// Add Settings Page
add_action('admin_menu', 'mystique_addmenu');

// Options handler for Settings Page
add_action('admin_post_mystique_update', 'mystique_update_options');

// Delete all Options if Theme is switched
if(get_mystique_option('remove_settings')) add_action('switch_theme', 'remove_mystique_options');


function mystique_setup_css() {
 global $themeurl;
 include('fontstyles.php');
 echo '<style type="text/css">'.PHP_EOL;
 $mystique_options = get_option('mystique');

 if($mystique_options['imageless']):
  echo '@import "'.$themeurl.'/style-imageless.css";'.PHP_EOL;
 else:
  echo '@import "'.get_bloginfo('stylesheet_url').'";'.PHP_EOL;
  echo '@import "'.$themeurl.'/color-'.$mystique_options['color_scheme'].'.css";'.PHP_EOL;
 endif;

 if($mystique_options['font_style']) echo 'body{font-family:'.$font_styles[$mystique_options['font_style']]['code'].';}'.PHP_EOL;

 if($mystique_options['background']) echo 'body{background-image:none;}'.PHP_EOL.'#page{background-image:url("'.$mystique_options['background'].'");background-repeat:no-repeat;background-position:center top;}'.PHP_EOL;
 if(($mystique_options['background_color']) && ($mystique_options['background_color']<>'#000000')):
  echo 'body{background-color:'.$mystique_options['background_color'].';}'.PHP_EOL;
  if (!$mystique_options['background']) echo 'body,#page{background-image:none;}'.PHP_EOL;
 endif;

 if(($mystique_options['layout']=='col-2-right') || (is_page_template('page-2col-right.php'))):
  if($mystique_options['main_width_2col']<>'70'):
   echo 'body.col-2-right #sidebar{width:'.(100-($mystique_options['main_width_2col'])).'%;}'.PHP_EOL;
   echo 'body.col-2-right #primary-content{width:'.$mystique_options['main_width_2col'].'%;}'.PHP_EOL;
  endif;
 elseif(($mystique_options['layout']=='col-3')  || (is_page_template('page-3col.php'))):
  if(($mystique_options['sidebar1_width_3col']<>'25') || ($mystique_options['sidebar2_width_3col']<>'25')):
   echo 'body.col-3 #sidebar{width:'.$mystique_options['sidebar1_width_3col'].'%;left:-'.((100-$mystique_options['sidebar1_width_3col']-$mystique_options['sidebar2_width_3col'])+$mystique_options['sidebar2_width_3col']).'%;}'.PHP_EOL;
   echo 'body.col-3 #sidebar2{width:'.$mystique_options['sidebar2_width_3col'].'%;left:'.$mystique_options['sidebar1_width_3col'].'%;}'.PHP_EOL;
   echo 'body.col-3 #primary-content{width:'.(100-$mystique_options['sidebar1_width_3col']-$mystique_options['sidebar2_width_3col']).'%;left:'.$mystique_options['sidebar1_width_3col'].'%;}'.PHP_EOL;
  endif;
 endif;


 if ($mystique_options['user_css']) echo $mystique_options['user_css'].PHP_EOL;
 echo '</style>'.PHP_EOL; ?>
<!--[if lte IE 6]>
<style type="text/css" media="screen">
 @import "<?php bloginfo('template_url'); ?>/ie6.css";
</style>
<![endif]-->
<!--[if IE 7]>
<style type="text/css" media="screen">
 @import "<?php bloginfo('template_url'); ?>/ie7.css";
</style>
<![endif]-->
 <?php
}
add_action('wp_head', 'mystique_setup_css',2);