<?php /* Mystique/digitalnature */


function youtube($atts){
  // example: [youtube embed=http://www.youtube.com/v/tmjbFT4NPjQ&hl width=425 height=344]
  extract(shortcode_atts(array(
   'embed' => FALSE,
   'width' => 425,
   'height' => 344,
  ), $atts));

  if(!$embed) return(FALSE);
  return(str_replace(array('%%embed%%','%%width%%','%%height%%'), array($embed, $width, $height), '<object type="application/x-shockwave-flash" style="width:%%width%%px; height:%%height%%px;" data="%%embed%%"><param name="movie" value="%%embed%%" /></object>'));
}
add_shortcode('youtube','youtube');


function googlechart($atts){
  extract(shortcode_atts(array(
   'data' => '',
   'colors' => '',
   'size' => '400x200',
   'bg' => 'ffffff',
   'title' => '',
   'labels' => '',
   'advanced' => '',
   'type' => 'pie'
  ), $atts));

  switch ($type) {
   case 'line': $charttype = 'lc'; break;
   case 'xyline': $charttype = 'lxy'; break;
   case 'sparkline': $charttype = 'ls'; break;
   case 'meter': $charttype = 'gom'; break;
   case 'scatter': $charttype = 's'; break;
   case 'venn': $charttype = 'v'; break;
   case 'pie': $charttype = 'p3'; break;
   case 'pie2d': $charttype = 'p'; break;
   default: $charttype = $type; break;
  }

  if ($title) $string .= '&chtt='.$title.'';
  if ($labels) $string .= '&chl='.$labels.'';
  if ($colors) $string .= '&chco='.$colors.'';
  $string .= '&chs='.$size.'';
  $string .= '&chd=t:'.$data.'';
  $string .= '&chf='.$bg.'';
  return '<img title="'.$title.'" src="http://chart.apis.google.com/chart?cht='.$charttype.''.$string.$advanced.'" alt="'.$title.'" />';
}
add_shortcode('googlechart', 'googlechart');


function queryposts($atts){
  extract( shortcode_atts( array(
   'category_id' => '',
   'category_name' => '',
   'tag' => '',
   'day' => '',
   'month' => '',
   'year' => '',
   'count' => '5',
   'author_id' => '',
   'author_name' => '',
   'order_by' => 'date',
  ), $atts) );

  $output = '';
  $query = array();

  if ($category_id != '') $query[] = 'cat=' .$category_id;
  if ($category_name != '') $query[] = 'category_name=' .$category_name;
  if ($tag != '') $query[] = 'tag=' . $tag;
  if ($day != '') $query[] = 'day=' . $day;
  if ($month != '') $query[] = 'monthnum=' . $month;
  if ($year != '') $query[] = 'year=' . $year;
  if ($count) $query[] = 'posts_per_page=' .$count;
  if ($author_id != '') $query[] = 'author=' . $author_id;
  if ($author_name != '') $query[] = 'author_name=' . $author_name;
  if ($order_by) $query[] = 'orderby=' . $order_by;

  $backup = $post;
  $posts = new WP_Query(implode('&',$query));

  while ($posts->have_posts()): $posts->the_post();

    $category = get_the_category();
    $category_name = $category[0]->cat_name;
    if(!empty($category_name)) $category_link = '<a href="'.get_category_link($category[0]->cat_ID).'">'.strip_string(34,$category_name).'</a>';
    if(function_exists('the_post_thumbnail'))
     if (has_post_thumbnail()) $post_thumb = true; else $post_thumb = false;

    $post_preview = get_mystique_option('post_preview');

    $output .= '<div class="post clearfix preview-'.$post_preview.'">';
    $output .= '<h2 class="title"><a href="'.get_permalink().'" rel="bookmark" title="'.__('Permanent Link:','mystique').' '.get_the_title().'">'.get_the_title().'</a></h2>';

    if($post_thumb) $output .= '<a class="post-thumb alignleft" href="'.get_permalink().'">'.get_the_post_thumbnail($post->ID,'thumbnail').'</a>';

    $output .= '<div class="post-date">';
    $output .= '<p class="day">'.get_the_time(__('M jS','mystique')).'</p>';
    $output .= '</div>';

    $output .= '<div class="post-info clearfix '.($post_thumb ? 'with-thumbs' : null).'">';
    $output .= '<p class="author alignleft">'.sprintf(__('Posted by %1$s in %2$s','mystique'),'<a href="'. get_author_posts_url(get_the_author_ID()) .'" title="'. sprintf(__("Posts by %s","mystique"), attribute_escape(get_the_author())).' ">'. get_the_author() .'</a>',$category_link);

    //if(function_exists('the_views')): $output .= '<span class="postviews">| '.get_the_views().'</span>'; endif;

    // edit_post_link(__('Edit','mystique'),' | ');
    $output .= '</p>';

    if (comments_open() || $comments):
     // global $id, $comment;
     $comments_number = get_comments_number();
     $output .= '<p class="comments alignright"><a href="'.get_permalink().'#comments" class="';
     if(($comments_number)==0) $output .= 'no ';
     $output .= 'comments">';
     if ($comments_number>1) $output .= sprintf(__('%s comments'),$comments_number);
     else if ($comments_number==1) $output .= __('1 comment');
     else  $output .= __('No comments');
     $output .= '</a></p>';

    endif;

    $output .= '</div>';

    if($post_preview<>'title'):
      $output .= '<div class="post-content clearfix">';
      if($post_preview=='excerpt') $output .= get_the_excerpt(); else $output .= get_the_content(__('Read the rest of this entry &raquo;', 'mystique'));
      $output .= '</div>';
      //if(function_exists('the_ratings')) $output .= get_the_ratings();
      $post_tags = get_the_tags();
      if ($post_tags):
        $output .= '<div class="post-tags">';
        $tags = array();
        $i = 0;
        foreach($post_tags as $tag):
         $tags[$i] .=  '<a href="'.get_tag_link($tag->term_id).'" rel="tag" title="'.sprintf(__('%s (%s topics)'),$tag->name,$tag->count).'">'.$tag->name.'</a>';
         $i++;
        endforeach;
        $output .= implode(', ',$tags);
        $output .= '</div>';
      endif;

    endif;
    $output .= '</div>';
  endwhile;

  $post = $backup;
  wp_reset_query();

  return $output;
}
add_shortcode('query', 'queryposts');


// member/visitor only content - based on http://justintadlock.com/archives/2009/05/09/using-shortcodes-to-show-members-only-content

function memberonlycontent($atts, $content = null){
  if (is_user_logged_in() && !is_null($content) && !is_feed()) return $content;
  return '';
}
add_shortcode('member', 'memberonlycontent');

function visitoronlycontent($atts, $content = null){
  if ((!is_user_logged_in() && !is_null($content)) || is_feed()) return $content;
  return '';
}
add_shortcode('visitor', 'visitoronlycontent');


// disable wp formmating
function noformatting($content) {
  $new_content = '';
  $pattern_full = '{(\[raw\].*?\[/raw\])}is';
  $pattern_contents = '{\[raw\](.*?)\[/raw\]}is';
  $pieces = preg_split($pattern_full, $content, -1, PREG_SPLIT_DELIM_CAPTURE);

  foreach ($pieces as $piece):
   if (preg_match($pattern_contents, $piece, $matches)) $new_content .= $matches[1];
   else $new_content .= wptexturize(wpautop($piece));
  endforeach;
  return $new_content;
}
remove_filter('the_content', 'wpautop');
remove_filter('the_content', 'wptexturize');
add_filter('the_content', 'noformatting', 99);

function subscribe_rss(){
  $subscribe = '<a class="rss-subscribe" href="'. get_bloginfo('rss2_url') .'" title="'. __('RSS Feeds','mystique') .'">'. __('RSS Feeds','mystique') .'</a>';
  return apply_filters('subscribe_rss', $subscribe);
}
add_shortcode('rss', 'subscribe_rss');


function tinyurl($atts){
  extract(shortcode_atts(array(
   'url' => '',
   'title' => '',
   'rel' => 'nofollow'
  ), $atts));
  if(!$title) $title = $url;
  $tinyurl = '<a href="'.getTinyUrl($url).'" rel="'.$rel.'">'.$title.'</a>';
  return apply_filters('tinyurl', $tinyurl);
}
add_shortcode('tinyurl', 'tinyurl');


// ads
function advertisment($atts){
  extract(shortcode_atts(array(
   'code' => 1,
   'align' => 'left',
   'inline' => 0
  ), $atts));
  $ad = get_mystique_option('ad_code_'.$code);
  if(!empty($ad)):
   $ad = '<div class="ad align'.$align.'">'.$ad.'</div>';
   if(!$inline) $ad = '<div class="clearfix">'.$ad.'</div>';
   return apply_filters('advertisment', $ad);
  else:
   return '<p class="error">'.sprintf(__("Empty ad slot (#%s)!","mystique"),$code).'</p>';
  endif;
}
add_shortcode('ad', 'advertisment');


function go_to_top(){
  $link = sprintf('<a id="goTop" class="js-link">'.__('Top','mystique').'</a>');
  return apply_filters('go_to_top', $link);
}
add_shortcode('top', 'go_to_top');

function theme_link(){
  $theme_link = sprintf('<a class="theme-link" href="%1$s" title ="Mystique %2$s" rel="designer">Mystique</a>', THEME_URI, THEME_VERSION );
  return apply_filters('theme_link', $theme_link);
}
add_shortcode('theme-link', 'theme_link');

function credit(){
  $credit = sprintf(__('Mystique theme by %1$s | Powered by %2$s', 'mystique'), '<a href="http://digitalnature.ro">digitalnature</a>', '<a href="http://wordpress.org/">WordPress</a>');
  return apply_filters('credit', $credit);
}
add_shortcode('credit', 'credit');

function copyright() {
  $copyright = sprintf('<span class="copyright"><span class="text">%1$s</span> <span class="the-year">%2$s</span> <a class="blog-title" href="%3$s" title="%4$s">%4$s</a></span>',
                        __('Copyright &copy;', 'mystique'),
                        date('Y'),
                        get_bloginfo('url'),
                        get_bloginfo('name'));
  return apply_filters('copyright', $copyright);
}
add_shortcode('copyright', 'copyright');

function wp_link(){
  $wp_link = '<a class="wp-link" href="http://WordPress.org/" title="WordPress" rel="generator">WordPress</a>';
  return apply_filters('wp_link', $wp_link);
}
add_shortcode('wp-link', 'wp_link');

// login
function login_link(){
  if (is_user_logged_in()) $link = sprintf('<a class="login-link" href="%1$s">%2$s</a>',admin_url(),__('Site Admin'));
  else $link = sprintf('<a class="login-link" href="%1$s">%2$s</a>',wp_login_url(),__('Log in'));
  return apply_filters('login_link', $link);
}
add_shortcode('login-link', 'login_link');

// blog title
function blog_title(){
  $blog_title = '<span class="blog-title">' . get_bloginfo('name') . '</span>';
  return apply_filters('blog_title', $blog_title);
}
add_shortcode('blog-title', 'blog_title');

// validate xhtml
function validate_xhtml(){
  $validate_xhtml = '<a class="valid-xhtml" href="http://validator.w3.org/check?uri=referer" title="Valid XHTML">XHTML 1.1</a>';
  return apply_filters('validate_xhtml', $validate_xhtml);
}
add_shortcode('xhtml', 'validate_xhtml');

// validate css
function validate_css(){
  $validate_css = '<a class="valid-css" href="http://jigsaw.w3.org/css-validator/check/referer?profile=css3" title="Valid CSS">CSS 3.0</a>';
  return apply_filters('validate_css', $validate_css);
}
add_shortcode('css', 'validate_css');


function theme_name(){ return THEME_NAME; }
add_shortcode('theme-name', 'theme_name');

function theme_author(){ return THEME_AUTHOR; }
add_shortcode('theme-author', 'theme_author');

function theme_uri(){ return THEME_URI; }
add_shortcode('theme-uri', 'theme_uri');


add_filter( 'widget_text', 'do_shortcode' ); // Allow [SHORTCODES] in Widgets
?>